<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<title>WebsiteVer2/forums/newbb_to_phpbb</title>
<link rel="stylesheet" type="text/css" media="all" charset="utf-8" href="modern/css/common.css">
<link rel="stylesheet" type="text/css" media="screen" charset="utf-8" href="modern/css/screen.css">
<link rel="stylesheet" type="text/css" media="print" charset="utf-8" href="modern/css/print.css">
<style type="text/css">
ul.pagetitle{
  display: inline;
  margin: 0;
  padding: 0;
  font-size: 1.5em;
}
li.pagetitle{
  display: inline;
  margin: 0;
}
td.noborder {
  border: 0;
}
</style>
</head>
<body>
<table>
<tr>
<td class="noborder">
<img src="logo.png">
</td>
<td class="noborder">
<ul class="pagetitle">
<li class="pagetitle"><a class="backlink">WebsiteVer2/forums/newbb_to_phpbb</a>
</ul>
<br><br>
[<a href="FrontPage.html">FrontPage</a>]&nbsp;[<a href="TitleIndex.html">TitleIndex</a>]&nbsp;[<a href="WordIndex.html">WordIndex</a>]&nbsp;
</td>
</tr>
</table>
<hr>
<div id="page"><h1 style="background-color:Red; color:White">This is a read-only <a href="https://gitlab.com/CentOS/docs/wiki_archives">archived version</a> of wiki.centos.org</h1>
<div dir="ltr" id="content" lang="en"><span class="anchor" id="top"></span>
<span class="anchor" id="line-1"></span><span class="anchor" id="line-2"></span><span class="anchor" id="line-3"></span><p class="line867">
<h1 id="Convert_Xoops.2B-CBB.28newbb.29_to_phpBB">Convert Xoops+CBB(newbb) to phpBB</h1>
<span class="anchor" id="line-4"></span><span class="anchor" id="line-5"></span><p class="line862">newbb_to_phpbb is a php script used to migrate the <a class="http" href="http://xoopsforge.com/XOOPS">Community Bulletin Board</a> (a.k.a newbb) into a <a class="http" href="http://www.phpbb.com/">phpBB</a>. <span class="anchor" id="line-6"></span><span class="anchor" id="line-7"></span><p class="line867"><div class="table-of-contents"><p class="table-of-contents-heading">Contents<ol><li>
<a href="#Releases">Releases</a></li><li>
<a href="#Screenshots">Screenshots</a></li><li>
<a href="#Configuration">Configuration</a></li><li>
<a href="#Forums">Forums</a></li><li>
<a href="#Users">Users</a><ol><li>
<a href="#userPassword_issue">userPassword issue</a></li><li>
<a href="#Manage_LDAP_user_information">Manage LDAP user information</a></li></ol></li><li>
<a href="#Topics">Topics</a></li><li>
<a href="#Posts">Posts</a></li><li>
<a href="#Resynchronizing">Resynchronizing</a></li></ol></li></ol></div> <span class="anchor" id="line-8"></span><span class="anchor" id="line-9"></span><p class="line867">
<h2 id="Releases">1. Releases</h2>
<span class="anchor" id="line-10"></span><span class="anchor" id="line-11"></span><ul><li><p class="line891"><strong><a class="attachment" href="attachments/WebsiteVer2(2f)forums(2f)newbb_to_phpbb/newbb_to_phpbb-0.2.tar.gz" title="">newbb_to_phpbb-0.2.tar.gz</a></strong> <small>(MD5: 67bf6edc863e486f2d9ccefdc0aa487e) </small> <span class="anchor" id="line-12"></span></li><li><p class="line891"><strong><a class="attachment" href="attachments/WebsiteVer2(2f)forums(2f)newbb_to_phpbb/newbb_to_phpbb-0.1.tar.gz" title="">newbb_to_phpbb-0.1.tar.gz</a></strong> <small>(MD5: 284cc146874b440e4bf365806842a2ee) </small> <span class="anchor" id="line-13"></span><span class="anchor" id="line-14"></span></li></ul><p class="line867">
<h2 id="Screenshots">2. Screenshots</h2>
<span class="anchor" id="line-15"></span><span class="anchor" id="line-16"></span><div><table><tbody><tr>  <td style="padding:0"><p class="line862"> <a class="attachment" href="attachments/WebsiteVer2(2f)forums(2f)newbb_to_phpbb/Screenshot-308.png" title="{{attachment:Screenshot-308.png||width=200}}"><img alt="attachment:Screenshot-308.png" class="attachment" src="attachments/WebsiteVer2(2f)forums(2f)newbb_to_phpbb/Screenshot-308.png" title="attachment:Screenshot-308.png" width="200" /></a> </td>
  <td colspan="2" style="padding:0; text-align: center"><p class="line862"> <a class="attachment" href="attachments/WebsiteVer2(2f)forums(2f)newbb_to_phpbb/Screenshot-309.png" title="{{attachment:Screenshot-309.png||width=200}}"><img alt="attachment:Screenshot-309.png" class="attachment" src="attachments/WebsiteVer2(2f)forums(2f)newbb_to_phpbb/Screenshot-309.png" title="attachment:Screenshot-309.png" width="200" /></a></td>
  <td colspan="2" style="padding:0; text-align: center"><p class="line862"> <a class="attachment" href="attachments/WebsiteVer2(2f)forums(2f)newbb_to_phpbb/Screenshot-310.png" title="{{attachment:Screenshot-310.png||width=200}}"><img alt="attachment:Screenshot-310.png" class="attachment" src="attachments/WebsiteVer2(2f)forums(2f)newbb_to_phpbb/Screenshot-310.png" title="attachment:Screenshot-310.png" width="200" /></a></td>
</tr>
<tr>  <td style="padding:0"><span class="anchor" id="line-17"></span><p class="line862"> <a class="attachment" href="attachments/WebsiteVer2(2f)forums(2f)newbb_to_phpbb/Screenshot-311.png" title="{{attachment:Screenshot-311.png||width=200}}"><img alt="attachment:Screenshot-311.png" class="attachment" src="attachments/WebsiteVer2(2f)forums(2f)newbb_to_phpbb/Screenshot-311.png" title="attachment:Screenshot-311.png" width="200" /></a></td>
  <td colspan="2" style="padding:0; text-align: center"><p class="line862"> <a class="attachment" href="attachments/WebsiteVer2(2f)forums(2f)newbb_to_phpbb/Screenshot-312.png" title="{{attachment:Screenshot-312.png||width=200}}"><img alt="attachment:Screenshot-312.png" class="attachment" src="attachments/WebsiteVer2(2f)forums(2f)newbb_to_phpbb/Screenshot-312.png" title="attachment:Screenshot-312.png" width="200" /></a></td>
  <td colspan="2" style="text-align: center"><p class="line862"> </td>
</tr>
</tbody></table></div><span class="anchor" id="line-18"></span><span class="anchor" id="line-19"></span><p class="line867">
<h2 id="Configuration">3. Configuration</h2>
<span class="anchor" id="line-20"></span><span class="anchor" id="line-21"></span><p class="line862">Before you could use this script, you need to configure some values. These values are set in the file <tt class="backtick">config.php</tt>. <span class="anchor" id="line-22"></span><span class="anchor" id="line-23"></span><div><table><tbody><tr>  <td class="lmimg orange" style="padding:0"><p class="line862"> <img alt="ArtWork/WikiDesign/icon-admonition-alert.png" class="attachment" src="attachments/ArtWork(2f)WikiDesign/icon-admonition-alert.png" title="ArtWork/WikiDesign/icon-admonition-alert.png" /> </td>
  <td class="lmtxt orange" colspan="2" style="padding:0; text-align: left"><p class="line862"> <strong>ATTENTION:</strong> In order to get a sucessful migration, id values should start at 1 in the following tables: <tt class="backtick">xoops.bb_forums</tt>, <tt class="backtick">xoops.bb_topics</tt>, <tt class="backtick">xoops.bb_posts</tt>, <tt class="backtick">xoops.bb_posts_text</tt>.</td>
</tr>
</tbody></table></div><span class="anchor" id="line-24"></span><span class="anchor" id="line-25"></span><div><table><tbody><tr>  <td class="lmimg orange" style="padding:0"><p class="line862"> <img alt="ArtWork/WikiDesign/icon-admonition-alert.png" class="attachment" src="attachments/ArtWork(2f)WikiDesign/icon-admonition-alert.png" title="ArtWork/WikiDesign/icon-admonition-alert.png" /> </td>
  <td class="lmtxt orange" colspan="2" style="padding:0; text-align: left"><p class="line862"> <strong>ATTENTION:</strong> In order to get a successful migration, the following tables are truncated before copying data into them: <tt class="backtick">phpBB.forums</tt>, <tt class="backtick">phpBB.topics</tt>, <tt class="backtick">phpBB.posts</tt>.</td>
</tr>
</tbody></table></div><span class="anchor" id="line-26"></span><span class="anchor" id="line-27"></span><div><table><tbody><tr>  <td class="lmimg orange" style="padding:0"><p class="line862"> <img alt="ArtWork/WikiDesign/icon-admonition-alert.png" class="attachment" src="attachments/ArtWork(2f)WikiDesign/icon-admonition-alert.png" title="ArtWork/WikiDesign/icon-admonition-alert.png" /> </td>
  <td class="lmtxt orange" colspan="2" style="padding:0; text-align: left"><p class="line862"> <strong>ATTENTION:</strong> Newbb forum categories are not copied. In phpBB there are not forum categories. </td>
</tr>
</tbody></table></div><span class="anchor" id="line-28"></span><span class="anchor" id="line-29"></span><p class="line867">
<h2 id="Forums">4. Forums</h2>
<span class="anchor" id="line-30"></span><span class="anchor" id="line-31"></span><p class="line867"><span class="anchor" id="line-32"></span><span class="anchor" id="line-33"></span><pre><span class="anchor" id="line-1"></span>    $newbb_to_phpbb-&gt;copy_Forums()</pre><span class="anchor" id="line-34"></span><span class="anchor" id="line-35"></span><p class="line862">The forum's order is controlled by the fields <tt class="backtick">xoops.bb_fourms.left_id</tt> and <tt class="backtick">xoops.bb_forums.right_id</tt>. If this fields are not properly set errors may happen. <span class="anchor" id="line-36"></span><span class="anchor" id="line-37"></span><p class="line867">
<h2 id="Users">5. Users</h2>
<span class="anchor" id="line-38"></span><span class="anchor" id="line-39"></span><p class="line867"><span class="anchor" id="line-40"></span><span class="anchor" id="line-41"></span><pre><span class="anchor" id="line-1-1"></span>    $newbb_to_phpbb-&gt;copy_Users()</pre><span class="anchor" id="line-42"></span><span class="anchor" id="line-43"></span><p class="line862">In our configuration, users are stored in an LDAP server. We use <tt class="backtick">copy_Users()</tt> function to copy users from <tt class="backtick">xoops.users</tt> table into our LDAP server. An example entry looks like the following: <span class="anchor" id="line-44"></span><span class="anchor" id="line-45"></span><p class="line867"><span class="anchor" id="line-46"></span><span class="anchor" id="line-47"></span><span class="anchor" id="line-48"></span><span class="anchor" id="line-49"></span><span class="anchor" id="line-50"></span><span class="anchor" id="line-51"></span><span class="anchor" id="line-52"></span><span class="anchor" id="line-53"></span><span class="anchor" id="line-54"></span><span class="anchor" id="line-55"></span><span class="anchor" id="line-56"></span><span class="anchor" id="line-57"></span><span class="anchor" id="line-58"></span><pre><span class="anchor" id="line-1-2"></span>    # al@example.com, people, example.com
<span class="anchor" id="line-2"></span>    dn: uid=al@example.com,ou=people,dc=example,dc=com
<span class="anchor" id="line-3"></span>    objectClass: inetOrgPerson
<span class="anchor" id="line-4"></span>    cn: Alain Reguera Delgado
<span class="anchor" id="line-5"></span>    mail: al@example.com
<span class="anchor" id="line-6"></span>    userPassword:: e01ENX1QUDFEYVJtOE1RZldpNUV1NWtmelFRPT0=
<span class="anchor" id="line-7"></span>    sn: Reguera Delgado
<span class="anchor" id="line-8"></span>    uid: al@example.com
<span class="anchor" id="line-9"></span>    uid: al
<span class="anchor" id="line-10"></span>    displayName: al
<span class="anchor" id="line-11"></span>    employeeType: writer
<span class="anchor" id="line-12"></span>    preferredLanguage: en</pre><span class="anchor" id="line-59"></span><span class="anchor" id="line-60"></span><div><table><tbody><tr>  <td class="lmimg orange" style="padding:0"><p class="line862"> <img alt="ArtWork/WikiDesign/icon-admonition-alert.png" class="attachment" src="attachments/ArtWork(2f)WikiDesign/icon-admonition-alert.png" title="ArtWork/WikiDesign/icon-admonition-alert.png" /> </td>
  <td class="lmtxt orange" colspan="2" style="padding:0; text-align: left"><p class="line862"> <strong>ATTENTION:</strong> Any distinguished name (DN) in LDAP server, under the basedn, and equal to that one formed from <tt class="backtick">xoops.users</tt> during the migration process, will be removed and replaced for the new one. Verify your LDAP users DNs before doing the migration.</td>
</tr>
</tbody></table></div><span class="anchor" id="line-61"></span><span class="anchor" id="line-62"></span><div><table><tbody><tr>  <td class="lmimg orange" style="padding:0"><p class="line862"> <img alt="ArtWork/WikiDesign/icon-admonition-alert.png" class="attachment" src="attachments/ArtWork(2f)WikiDesign/icon-admonition-alert.png" title="ArtWork/WikiDesign/icon-admonition-alert.png" /> </td>
  <td class="lmtxt orange" colspan="2" style="padding:0; text-align: left"><p class="line862"> <strong>ATTENTION:</strong> All records in <tt class="backtick">phpBB.users.user_id&nbsp;&gt;&nbsp;52</tt> will be removed in the user's migration process.</td>
</tr>
</tbody></table></div><span class="anchor" id="line-63"></span><span class="anchor" id="line-64"></span><div><table><tbody><tr>  <td class="lmimg blue" style="padding:0"><p class="line862"> <img alt="ArtWork/WikiDesign/icon-admonition-info.png" class="attachment" src="attachments/ArtWork(2f)WikiDesign/icon-admonition-info.png" title="ArtWork/WikiDesign/icon-admonition-info.png" /> </td>
  <td class="lmtxt blue" colspan="2" style="padding:0; text-align: left"><p class="line862"> <strong>NOTE:</strong> All users will be inserted using the default phpBB group (<tt class="backtick">REGISTERED</tt>). Once the user migration is complete, the phpBB administrator should reset user permission and define moderators. </td>
</tr>
</tbody></table></div><span class="anchor" id="line-65"></span><span class="anchor" id="line-66"></span><p class="line862">When users entries are added into LDAP server they remain there available to be used as authentication credentials by phpbb system. At that moment if the LDAP authentication against LDAP <tt class="backtick">uid</tt> and <tt class="backtick">userPassword</tt> attributes is correct, the phpBB system inserts a new record for that user into the <tt class="backtick">phpBB.users</tt> table if it found that the <tt class="backtick">username_clean</tt> do exists for the <tt class="backtick">uid</tt> provided. This way, it is established the relationship among phpBB.users and phpBB.topics and phpBB.posts. <span class="anchor" id="line-67"></span><span class="anchor" id="line-68"></span><p class="line862">Users can have more than one uid in its LDAP entry and can login into phpBB system using any of them. In that case a different user will be created in the database for each one used. In the example above user can login using <tt class="backtick">al</tt> or <tt class="backtick">al@example.com</tt> uid. <span class="anchor" id="line-69"></span><span class="anchor" id="line-70"></span><div><table><tbody><tr>  <td class="lmimg blue" style="padding:0"><p class="line862"> <img alt="ArtWork/WikiDesign/icon-admonition-info.png" class="attachment" src="attachments/ArtWork(2f)WikiDesign/icon-admonition-info.png" title="ArtWork/WikiDesign/icon-admonition-info.png" /> </td>
  <td class="lmtxt blue" colspan="2" style="padding:0; text-align: left"><p class="line862"> <strong>NOTE:</strong> This configuration was built with <a class="http" href="http://tools.ietf.org/html/rfc2377">rfc2377</a> in mind. Additionally, it was added a second uid attribute (Ex. <tt class="backtick">al</tt>) for those users whom don't want to be logged in with email address. Anyway this is something that could be discussed, so we could find a better configuration. When doing so, remember that users entries in LDAP sever may be used for other applications and that the directory may grow considerably.</td>
</tr>
</tbody></table></div><span class="anchor" id="line-71"></span><span class="anchor" id="line-72"></span><p class="line874">When a user is removed from phpBB database it is only removed from phpBB database. No LDAP action is present here to remove the related user's entry from LDAP server. <span class="anchor" id="line-73"></span><span class="anchor" id="line-74"></span><p class="line874">If phpBB was configured to use LDAP server as authentication method, users will be able to log in as long as they be present in the LDAP server and no restrictive permission be implemented for it in phpBB system. <span class="anchor" id="line-75"></span><span class="anchor" id="line-76"></span><p class="line867">
<h3 id="userPassword_issue">5.1. userPassword issue</h3>
<span class="anchor" id="line-77"></span><span class="anchor" id="line-78"></span><p class="line862">Once the <tt class="backtick">xoops.users</tt> information is copied into LDAP server, users' passwords need to be reset. This is because when user's password is copied into LDAP server it re-codified to fit format of the `userPassword' LDAP attribute and what is re-codified is not the user password itself but the hash of it. <span class="anchor" id="line-79"></span><span class="anchor" id="line-80"></span><p class="line862">To solve this issue the <em>Resetting LDAP userPassword</em> functionality is provided in this script. You need to run it once users are successfully copied into LDAP server. Basically, what this functionality does is generate a random password for each LDAP user and use the user's mail attribute to notify the user of its new password and the need of update it. <span class="anchor" id="line-81"></span><span class="anchor" id="line-82"></span><p class="line867">
<h3 id="Manage_LDAP_user_information">5.2. Manage LDAP user information</h3>
<span class="anchor" id="line-83"></span><span class="anchor" id="line-84"></span><p class="line874">To manage LDAP user information, a web application should be provided, so the user can update its information. Also, to let administrator manage LDAP users easily. <span class="anchor" id="line-85"></span><span class="anchor" id="line-86"></span><p class="line867">
<h2 id="Topics">6. Topics</h2>
<span class="anchor" id="line-87"></span><span class="anchor" id="line-88"></span><p class="line867"><span class="anchor" id="line-89"></span><span class="anchor" id="line-90"></span><pre><span class="anchor" id="line-1-3"></span>    $newbb_to_phpbb-&gt;copy_Topics()</pre><span class="anchor" id="line-91"></span><span class="anchor" id="line-92"></span><p class="line862">Once topics migration is complete, all topics will be owned by the <tt class="backtick">administrator</tt> user (<tt class="backtick">phpBB.users.user_id&nbsp;=&nbsp;2</tt>). <span class="anchor" id="line-93"></span><span class="anchor" id="line-94"></span><p class="line867">
<h2 id="Posts">7. Posts</h2>
<span class="anchor" id="line-95"></span><span class="anchor" id="line-96"></span><p class="line867"><span class="anchor" id="line-97"></span><span class="anchor" id="line-98"></span><pre><span class="anchor" id="line-1-4"></span>    $newbb_to_phpbb-&gt;copy_Posts()</pre><span class="anchor" id="line-99"></span><span class="anchor" id="line-100"></span><p class="line862">Once posts migration is complete, all topics will be owned by the <tt class="backtick">administrator</tt> user (<tt class="backtick">phpBB.users.user_id&nbsp;=&nbsp;2</tt>). <span class="anchor" id="line-101"></span><span class="anchor" id="line-102"></span><p class="line867">
<h2 id="Resynchronizing">8. Resynchronizing</h2>
<span class="anchor" id="line-103"></span><span class="anchor" id="line-104"></span><p class="line874">After the overall migration process, it is convenient to resynchronize forums in phpBB using the "Administration Control Panel". <span class="anchor" id="line-105"></span><span class="anchor" id="bottom"></span></div>
</div>
<hr>
2023-09-11 07:23
</body>
</html>
